Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for Albums
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class AlbumsController
    
        ' Preload our schema..
        Dim thisSchemaLoad As Albums = New Albums()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AlbumsCollection
        
            Dim coll As AlbumsCollection = New AlbumsCollection()
            Dim qry As Query = New Query(Albums.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Albumid As Object) As AlbumsCollection 
        
            Dim coll As AlbumsCollection = New AlbumsCollection().Where("albumid", Albumid).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AlbumsCollection 
        
            Dim coll As AlbumsCollection = New AlbumsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Albumid As Object) as Boolean
        
            Return (Albums.Delete(Albumid) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Albumid As Object) as Boolean
        
            Return (Albums.Destroy(Albumid) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Title As String,ByVal Parentid As Integer,ByVal Isprivate As Nullable(Of Boolean),ByVal Description As String,ByVal Ownerid As Guid)
	   
		    Dim item As Albums = New Albums()
		    
            item.Title = Title
            
            item.Parentid = Parentid
            
            item.Isprivate = Isprivate
            
            item.Description = Description
            
            item.Ownerid = Ownerid
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Albumid As Integer,ByVal Title As String,ByVal Parentid As Integer,ByVal Isprivate As Nullable(Of Boolean),ByVal Description As String,ByVal Ownerid As Guid)
	    
		    Dim item As Albums = New Albums()
		    
				item.Albumid = Albumid
				
				item.Title = Title
				
				item.Parentid = Parentid
				
				item.Isprivate = Isprivate
				
				item.Description = Description
				
				item.Ownerid = Ownerid
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
