Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for Announcements
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class AnnouncementsController
    
        ' Preload our schema..
        Dim thisSchemaLoad As Announcements = New Announcements()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AnnouncementsCollection
        
            Dim coll As AnnouncementsCollection = New AnnouncementsCollection()
            Dim qry As Query = New Query(Announcements.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As AnnouncementsCollection 
        
            Dim coll As AnnouncementsCollection = New AnnouncementsCollection().Where("id", Id).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AnnouncementsCollection 
        
            Dim coll As AnnouncementsCollection = New AnnouncementsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) as Boolean
        
            Return (Announcements.Delete(Id) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) as Boolean
        
            Return (Announcements.Destroy(Id) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Itemdate As DateTime,ByVal Title As String,ByVal Description As String,ByVal StaticURL As String,ByVal Photo As Integer,ByVal Albumid As Nullable(Of Integer))
	   
		    Dim item As Announcements = New Announcements()
		    
            item.Itemdate = Itemdate
            
            item.Title = Title
            
            item.Description = Description
            
            item.StaticURL = StaticURL
            
            item.Photo = Photo
            
            item.Albumid = Albumid
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer,ByVal Itemdate As DateTime,ByVal Title As String,ByVal Description As String,ByVal StaticURL As String,ByVal Photo As Integer,ByVal Albumid As Nullable(Of Integer))
	    
		    Dim item As Announcements = New Announcements()
		    
				item.Id = Id
				
				item.Itemdate = Itemdate
				
				item.Title = Title
				
				item.Description = Description
				
				item.StaticURL = StaticURL
				
				item.Photo = Photo
				
				item.Albumid = Albumid
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
