Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for aspnet_Paths
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class AspnetPathsController
    
        ' Preload our schema..
        Dim thisSchemaLoad As AspnetPaths = New AspnetPaths()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AspnetPathsCollection
        
            Dim coll As AspnetPathsCollection = New AspnetPathsCollection()
            Dim qry As Query = New Query(AspnetPaths.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal PathId As Object) As AspnetPathsCollection 
        
            Dim coll As AspnetPathsCollection = New AspnetPathsCollection().Where("PathId", PathId).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AspnetPathsCollection 
        
            Dim coll As AspnetPathsCollection = New AspnetPathsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal PathId As Object) as Boolean
        
            Return (AspnetPaths.Delete(PathId) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal PathId As Object) as Boolean
        
            Return (AspnetPaths.Destroy(PathId) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal ApplicationId As Guid,ByVal PathId As Guid,ByVal Path As String,ByVal LoweredPath As String)
	   
		    Dim item As AspnetPaths = New AspnetPaths()
		    
            item.ApplicationId = ApplicationId
            
            item.PathId = PathId
            
            item.Path = Path
            
            item.LoweredPath = LoweredPath
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal ApplicationId As Guid,ByVal PathId As Guid,ByVal Path As String,ByVal LoweredPath As String)
	    
		    Dim item As AspnetPaths = New AspnetPaths()
		    
				item.ApplicationId = ApplicationId
				
				item.PathId = PathId
				
				item.Path = Path
				
				item.LoweredPath = LoweredPath
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
