Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
	''' <summary>
	''' Strongly-typed collection for the AspnetProfile class.
	''' </summary>
	<Serializable> _
	Public Partial Class AspnetProfileCollection 
	Inherits ActiveList(Of AspnetProfile, AspnetProfileCollection)
	    Public Sub New()
		End Sub
	End Class
	''' <summary>
	''' This is an ActiveRecord class which wraps the aspnet_Profile table.
	''' </summary>
	<Serializable> _
	Public Partial Class AspnetProfile 
	Inherits ActiveRecord(Of AspnetProfile)
		#Region ".ctors and Default Settings"
		
		Public Sub New()
			SetSQLProps()
			InitSetDefaults()
			MarkNew()
		End Sub
		
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		Public Sub New(ByVal keyID As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByKey(keyID)
		End Sub
		Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByParam(columnName,columnValue)
		End Sub
		Private Sub InitSetDefaults()
			SetDefaults()
		End Sub
		
		Protected Shared Sub SetSQLProps()
			GetTableSchema()
		End Sub
		#End Region
		
		#Region "Schema and Query Accessor"
		
		Public Shared ReadOnly Property Schema() As TableSchema.Table
			Get
				If BaseSchema Is Nothing Then
					SetSQLProps()
				End If
				Return BaseSchema
			End Get
		End Property
		Private Shared Sub GetTableSchema()
			If (Not IsSchemaInitialized) Then
				'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_Profile", TableType.Table, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
				'columns
				
                
                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = false
                colvarUserId.IsNullable = false
                colvarUserId.IsPrimaryKey = true
                colvarUserId.IsForeignKey = true
                colvarUserId.IsReadOnly = false
                
                
				colvarUserId.ForeignKeyTableName = "aspnet_Users"
                
                schema.Columns.Add(colvarUserId)
                
                Dim colvarPropertyNames As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyNames.ColumnName = "PropertyNames"
                colvarPropertyNames.DataType = DbType.String
                colvarPropertyNames.MaxLength = 1073741823
                colvarPropertyNames.AutoIncrement = false
                colvarPropertyNames.IsNullable = false
                colvarPropertyNames.IsPrimaryKey = false
                colvarPropertyNames.IsForeignKey = false
                colvarPropertyNames.IsReadOnly = false
                
                
                schema.Columns.Add(colvarPropertyNames)
                
                Dim colvarPropertyValuesString As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyValuesString.ColumnName = "PropertyValuesString"
                colvarPropertyValuesString.DataType = DbType.String
                colvarPropertyValuesString.MaxLength = 1073741823
                colvarPropertyValuesString.AutoIncrement = false
                colvarPropertyValuesString.IsNullable = false
                colvarPropertyValuesString.IsPrimaryKey = false
                colvarPropertyValuesString.IsForeignKey = false
                colvarPropertyValuesString.IsReadOnly = false
                
                
                schema.Columns.Add(colvarPropertyValuesString)
                
                Dim colvarPropertyValuesBinary As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyValuesBinary.ColumnName = "PropertyValuesBinary"
                colvarPropertyValuesBinary.DataType = DbType.Binary
                colvarPropertyValuesBinary.MaxLength = 2147483647
                colvarPropertyValuesBinary.AutoIncrement = false
                colvarPropertyValuesBinary.IsNullable = false
                colvarPropertyValuesBinary.IsPrimaryKey = false
                colvarPropertyValuesBinary.IsForeignKey = false
                colvarPropertyValuesBinary.IsReadOnly = false
                
                
                schema.Columns.Add(colvarPropertyValuesBinary)
                
                Dim colvarLastUpdatedDate As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLastUpdatedDate.ColumnName = "LastUpdatedDate"
                colvarLastUpdatedDate.DataType = DbType.DateTime
                colvarLastUpdatedDate.MaxLength = 0
                colvarLastUpdatedDate.AutoIncrement = false
                colvarLastUpdatedDate.IsNullable = false
                colvarLastUpdatedDate.IsPrimaryKey = false
                colvarLastUpdatedDate.IsForeignKey = false
                colvarLastUpdatedDate.IsReadOnly = false
                
                
                schema.Columns.Add(colvarLastUpdatedDate)
                
				BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("aspnet_Profile",schema)
			End If
		End Sub
		Public Shared Function CreateQuery() As Query
			Return New Query(Schema)
		End Function
		
		#End Region
		
		#Region "Props"
	
          
        <XmlAttribute("UserId")> _
        Public Property UserId As Guid 
			Get
				Return GetColumnValue(Of Guid)("UserId")
			End Get
		    
			Set
				SetColumnValue("UserId", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("PropertyNames")> _
        Public Property PropertyNames As String 
			Get
				Return GetColumnValue(Of String)("PropertyNames")
			End Get
		    
			Set
				SetColumnValue("PropertyNames", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("PropertyValuesString")> _
        Public Property PropertyValuesString As String 
			Get
				Return GetColumnValue(Of String)("PropertyValuesString")
			End Get
		    
			Set
				SetColumnValue("PropertyValuesString", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("PropertyValuesBinary")> _
        Public Property PropertyValuesBinary As Byte() 
			Get
				Return GetColumnValue(Of Byte())("PropertyValuesBinary")
			End Get
		    
			Set
				SetColumnValue("PropertyValuesBinary", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("LastUpdatedDate")> _
        Public Property LastUpdatedDate As DateTime 
			Get
				Return GetColumnValue(Of DateTime)("LastUpdatedDate")
			End Get
		    
			Set
				SetColumnValue("LastUpdatedDate", Value)
			End Set
		End Property
		
		
		
		
		#End Region
		
		
			    
	    
		
		
		
		
		
	    
	    #Region "ForeignKey Methods"
	    
		''' <summary>
		''' Returns a AspnetUsers ActiveRecord object related to this AspnetProfile
		''' </summary>
		Public Property AspnetUsers() As Data.AspnetUsers
			Get
				Return Data.AspnetUsers.FetchByID(Me.UserId)
			End Get
			Set
				SetColumnValue("UserId", Value.UserId)
			End Set
		End Property
	    
	    #End Region
	    
		
	    
	    'no ManyToMany tables defined (0)
	    
		
		#Region "ObjectDataSource support"
		
		''' <summary>
		''' Inserts a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Insert(ByVal varUserId As Guid,ByVal varPropertyNames As String,ByVal varPropertyValuesString As String,ByVal varPropertyValuesBinary As Byte(),ByVal varLastUpdatedDate As DateTime)
			Dim item As AspnetProfile = New AspnetProfile()
			
            item.UserId = varUserId
            
            item.PropertyNames = varPropertyNames
            
            item.PropertyValuesString = varPropertyValuesString
            
            item.PropertyValuesBinary = varPropertyValuesBinary
            
            item.LastUpdatedDate = varLastUpdatedDate
            
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		''' <summary>
		''' Updates a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Update(ByVal varUserId As Guid,ByVal varPropertyNames As String,ByVal varPropertyValuesString As String,ByVal varPropertyValuesBinary As Byte(),ByVal varLastUpdatedDate As DateTime)
			Dim item As AspnetProfile = New AspnetProfile()
		    
                item.UserId = varUserId
				
                item.PropertyNames = varPropertyNames
				
                item.PropertyValuesString = varPropertyValuesString
				
                item.PropertyValuesBinary = varPropertyValuesBinary
				
                item.LastUpdatedDate = varLastUpdatedDate
				
			item.IsNew = False
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		#End Region
		#Region "Columns Struct"
		Public Structure Columns
			Dim x as Integer
			
            Public Shared UserId As String = "UserId"
            
            Public Shared PropertyNames As String = "PropertyNames"
            
            Public Shared PropertyValuesString As String = "PropertyValuesString"
            
            Public Shared PropertyValuesBinary As String = "PropertyValuesBinary"
            
            Public Shared LastUpdatedDate As String = "LastUpdatedDate"
            
		End Structure
		#End Region
	End Class
End Namespace
