Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
	''' <summary>
	''' Strongly-typed collection for the Attendance class.
	''' </summary>
	<Serializable> _
	Public Partial Class AttendanceCollection 
	Inherits ActiveList(Of Attendance, AttendanceCollection)
	    Public Sub New()
		End Sub
	End Class
	''' <summary>
	''' This is an ActiveRecord class which wraps the Attendance table.
	''' </summary>
	<Serializable> _
	Public Partial Class Attendance 
	Inherits ActiveRecord(Of Attendance)
		#Region ".ctors and Default Settings"
		
		Public Sub New()
			SetSQLProps()
			InitSetDefaults()
			MarkNew()
		End Sub
		
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		Public Sub New(ByVal keyID As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByKey(keyID)
		End Sub
		Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByParam(columnName,columnValue)
		End Sub
		Private Sub InitSetDefaults()
			SetDefaults()
		End Sub
		
		Protected Shared Sub SetSQLProps()
			GetTableSchema()
		End Sub
		#End Region
		
		#Region "Schema and Query Accessor"
		
		Public Shared ReadOnly Property Schema() As TableSchema.Table
			Get
				If BaseSchema Is Nothing Then
					SetSQLProps()
				End If
				Return BaseSchema
			End Get
		End Property
		Private Shared Sub GetTableSchema()
			If (Not IsSchemaInitialized) Then
				'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("Attendance", TableType.Table, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
				'columns
				
                
                Dim colvarEventid As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventid.ColumnName = "eventid"
                colvarEventid.DataType = DbType.Int32
                colvarEventid.MaxLength = 0
                colvarEventid.AutoIncrement = false
                colvarEventid.IsNullable = false
                colvarEventid.IsPrimaryKey = true
                colvarEventid.IsForeignKey = false
                colvarEventid.IsReadOnly = false
                
                
                schema.Columns.Add(colvarEventid)
                
                Dim colvarMember As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMember.ColumnName = "member"
                colvarMember.DataType = DbType.Guid
                colvarMember.MaxLength = 0
                colvarMember.AutoIncrement = false
                colvarMember.IsNullable = false
                colvarMember.IsPrimaryKey = true
                colvarMember.IsForeignKey = false
                colvarMember.IsReadOnly = false
                
                
                schema.Columns.Add(colvarMember)
                
                Dim colvarNumofguest As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarNumofguest.ColumnName = "numofguest"
                colvarNumofguest.DataType = DbType.Int32
                colvarNumofguest.MaxLength = 0
                colvarNumofguest.AutoIncrement = false
                colvarNumofguest.IsNullable = false
                colvarNumofguest.IsPrimaryKey = false
                colvarNumofguest.IsForeignKey = false
                colvarNumofguest.IsReadOnly = false
                
                
                schema.Columns.Add(colvarNumofguest)
                
				BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("Attendance",schema)
			End If
		End Sub
		Public Shared Function CreateQuery() As Query
			Return New Query(Schema)
		End Function
		
		#End Region
		
		#Region "Props"
	
          
        <XmlAttribute("Eventid")> _
        Public Property Eventid As Integer 
			Get
				Return GetColumnValue(Of Integer)("eventid")
			End Get
		    
			Set
				SetColumnValue("eventid", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Member")> _
        Public Property Member As Guid 
			Get
				Return GetColumnValue(Of Guid)("member")
			End Get
		    
			Set
				SetColumnValue("member", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Numofguest")> _
        Public Property Numofguest As Integer 
			Get
				Return GetColumnValue(Of Integer)("numofguest")
			End Get
		    
			Set
				SetColumnValue("numofguest", Value)
			End Set
		End Property
		
		
		
		
		#End Region
		
		
			    
	    
		
		
		
		
		
	    
	    'no foreign key tables defined (0)
	    
		
	    
	    'no ManyToMany tables defined (0)
	    
		
		#Region "ObjectDataSource support"
		
		''' <summary>
		''' Inserts a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Insert(ByVal varEventid As Integer,ByVal varMember As Guid,ByVal varNumofguest As Integer)
			Dim item As Attendance = New Attendance()
			
            item.Eventid = varEventid
            
            item.Member = varMember
            
            item.Numofguest = varNumofguest
            
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		''' <summary>
		''' Updates a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Update(ByVal varEventid As Integer,ByVal varMember As Guid,ByVal varNumofguest As Integer)
			Dim item As Attendance = New Attendance()
		    
                item.Eventid = varEventid
				
                item.Member = varMember
				
                item.Numofguest = varNumofguest
				
			item.IsNew = False
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		#End Region
		#Region "Columns Struct"
		Public Structure Columns
			Dim x as Integer
			
            Public Shared Eventid As String = "eventid"
            
            Public Shared Member As String = "member"
            
            Public Shared Numofguest As String = "numofguest"
            
		End Structure
		#End Region
	End Class
End Namespace
