Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for BlogPosts
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class BlogPostsController
    
        ' Preload our schema..
        Dim thisSchemaLoad As BlogPosts = New BlogPosts()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As BlogPostsCollection
        
            Dim coll As BlogPostsCollection = New BlogPostsCollection()
            Dim qry As Query = New Query(BlogPosts.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Postid As Object) As BlogPostsCollection 
        
            Dim coll As BlogPostsCollection = New BlogPostsCollection().Where("postid", Postid).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As BlogPostsCollection 
        
            Dim coll As BlogPostsCollection = New BlogPostsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Postid As Object) as Boolean
        
            Return (BlogPosts.Delete(Postid) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Postid As Object) as Boolean
        
            Return (BlogPosts.Destroy(Postid) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Title As String,ByVal PostText As String,ByVal Postdate As DateTime,ByVal Memid As Guid)
	   
		    Dim item As BlogPosts = New BlogPosts()
		    
            item.Title = Title
            
            item.PostText = PostText
            
            item.Postdate = Postdate
            
            item.Memid = Memid
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Postid As Integer,ByVal Title As String,ByVal PostText As String,ByVal Postdate As DateTime,ByVal Memid As Guid)
	    
		    Dim item As BlogPosts = New BlogPosts()
		    
				item.Postid = Postid
				
				item.Title = Title
				
				item.PostText = PostText
				
				item.Postdate = Postdate
				
				item.Memid = Memid
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
