Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
	''' <summary>
	''' Strongly-typed collection for the Image class.
	''' </summary>
	<Serializable> _
	Public Partial Class ImageCollection 
	Inherits ActiveList(Of Image, ImageCollection)
	    Public Sub New()
		End Sub
	End Class
	''' <summary>
	''' This is an ActiveRecord class which wraps the image table.
	''' </summary>
	<Serializable> _
	Public Partial Class Image 
	Inherits ActiveRecord(Of Image)
		#Region ".ctors and Default Settings"
		
		Public Sub New()
			SetSQLProps()
			InitSetDefaults()
			MarkNew()
		End Sub
		
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		Public Sub New(ByVal keyID As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByKey(keyID)
		End Sub
		Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByParam(columnName,columnValue)
		End Sub
		Private Sub InitSetDefaults()
			SetDefaults()
		End Sub
		
		Protected Shared Sub SetSQLProps()
			GetTableSchema()
		End Sub
		#End Region
		
		#Region "Schema and Query Accessor"
		
		Public Shared ReadOnly Property Schema() As TableSchema.Table
			Get
				If BaseSchema Is Nothing Then
					SetSQLProps()
				End If
				Return BaseSchema
			End Get
		End Property
		Private Shared Sub GetTableSchema()
			If (Not IsSchemaInitialized) Then
				'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("image", TableType.Table, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
				'columns
				
                
                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "id"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = true
                colvarId.IsNullable = false
                colvarId.IsPrimaryKey = true
                colvarId.IsForeignKey = false
                colvarId.IsReadOnly = false
                
                
                schema.Columns.Add(colvarId)
                
                Dim colvarTitle As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarTitle.ColumnName = "title"
                colvarTitle.DataType = DbType.String
                colvarTitle.MaxLength = 50
                colvarTitle.AutoIncrement = false
                colvarTitle.IsNullable = false
                colvarTitle.IsPrimaryKey = false
                colvarTitle.IsForeignKey = false
                colvarTitle.IsReadOnly = false
                
                
                schema.Columns.Add(colvarTitle)
                
                Dim colvarImageFileName As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarImageFileName.ColumnName = "imageFileName"
                colvarImageFileName.DataType = DbType.String
                colvarImageFileName.MaxLength = 50
                colvarImageFileName.AutoIncrement = false
                colvarImageFileName.IsNullable = false
                colvarImageFileName.IsPrimaryKey = false
                colvarImageFileName.IsForeignKey = false
                colvarImageFileName.IsReadOnly = false
                
                
                schema.Columns.Add(colvarImageFileName)
                
                Dim colvarAlbum As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarAlbum.ColumnName = "album"
                colvarAlbum.DataType = DbType.Int32
                colvarAlbum.MaxLength = 0
                colvarAlbum.AutoIncrement = false
                colvarAlbum.IsNullable = false
                colvarAlbum.IsPrimaryKey = false
                colvarAlbum.IsForeignKey = false
                colvarAlbum.IsReadOnly = false
                
                
                schema.Columns.Add(colvarAlbum)
                
                Dim colvarNotes As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarNotes.ColumnName = "notes"
                colvarNotes.DataType = DbType.String
                colvarNotes.MaxLength = 500
                colvarNotes.AutoIncrement = false
                colvarNotes.IsNullable = true
                colvarNotes.IsPrimaryKey = false
                colvarNotes.IsForeignKey = false
                colvarNotes.IsReadOnly = false
                
                
                schema.Columns.Add(colvarNotes)
                
				BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("image",schema)
			End If
		End Sub
		Public Shared Function CreateQuery() As Query
			Return New Query(Schema)
		End Function
		
		#End Region
		
		#Region "Props"
	
          
        <XmlAttribute("Id")> _
        Public Property Id As Integer 
			Get
				Return GetColumnValue(Of Integer)("id")
			End Get
		    
			Set
				SetColumnValue("id", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Title")> _
        Public Property Title As String 
			Get
				Return GetColumnValue(Of String)("title")
			End Get
		    
			Set
				SetColumnValue("title", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("ImageFileName")> _
        Public Property ImageFileName As String 
			Get
				Return GetColumnValue(Of String)("imageFileName")
			End Get
		    
			Set
				SetColumnValue("imageFileName", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Album")> _
        Public Property Album As Integer 
			Get
				Return GetColumnValue(Of Integer)("album")
			End Get
		    
			Set
				SetColumnValue("album", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Notes")> _
        Public Property Notes As String 
			Get
				Return GetColumnValue(Of String)("notes")
			End Get
		    
			Set
				SetColumnValue("notes", Value)
			End Set
		End Property
		
		
		
		
		#End Region
		
		
			    
	    
		
		
		
		
		
	    
	    'no foreign key tables defined (0)
	    
		
	    
	    'no ManyToMany tables defined (0)
	    
		
		#Region "ObjectDataSource support"
		
		''' <summary>
		''' Inserts a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Insert(ByVal varTitle As String,ByVal varImageFileName As String,ByVal varAlbum As Integer,ByVal varNotes As String)
			Dim item As Image = New Image()
			
            item.Title = varTitle
            
            item.ImageFileName = varImageFileName
            
            item.Album = varAlbum
            
            item.Notes = varNotes
            
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		''' <summary>
		''' Updates a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Update(ByVal varId As Integer,ByVal varTitle As String,ByVal varImageFileName As String,ByVal varAlbum As Integer,ByVal varNotes As String)
			Dim item As Image = New Image()
		    
                item.Id = varId
				
                item.Title = varTitle
				
                item.ImageFileName = varImageFileName
				
                item.Album = varAlbum
				
                item.Notes = varNotes
				
			item.IsNew = False
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		#End Region
		#Region "Columns Struct"
		Public Structure Columns
			Dim x as Integer
			
            Public Shared Id As String = "id"
            
            Public Shared Title As String = "title"
            
            Public Shared ImageFileName As String = "imageFileName"
            
            Public Shared Album As String = "album"
            
            Public Shared Notes As String = "notes"
            
		End Structure
		#End Region
	End Class
End Namespace
