Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for images
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class ImagesController
    
        ' Preload our schema..
        Dim thisSchemaLoad As Images = New Images()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As ImagesCollection
        
            Dim coll As ImagesCollection = New ImagesCollection()
            Dim qry As Query = New Query(Images.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As ImagesCollection 
        
            Dim coll As ImagesCollection = New ImagesCollection().Where("id", Id).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As ImagesCollection 
        
            Dim coll As ImagesCollection = New ImagesCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) as Boolean
        
            Return (Images.Delete(Id) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) as Boolean
        
            Return (Images.Destroy(Id) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Title As String,ByVal Largeimage As Byte(),ByVal Thumbimage As Byte(),ByVal Origimage As Byte(),ByVal Album As Integer,ByVal Notes As String)
	   
		    Dim item As Images = New Images()
		    
            item.Title = Title
            
            item.Largeimage = Largeimage
            
            item.Thumbimage = Thumbimage
            
            item.Origimage = Origimage
            
            item.Album = Album
            
            item.Notes = Notes
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer,ByVal Title As String,ByVal Largeimage As Byte(),ByVal Thumbimage As Byte(),ByVal Origimage As Byte(),ByVal Album As Integer,ByVal Notes As String)
	    
		    Dim item As Images = New Images()
		    
				item.Id = Id
				
				item.Title = Title
				
				item.Largeimage = Largeimage
				
				item.Thumbimage = Thumbimage
				
				item.Origimage = Origimage
				
				item.Album = Album
				
				item.Notes = Notes
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
