Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for PollAnswers
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class PollAnswersController
    
        ' Preload our schema..
        Dim thisSchemaLoad As PollAnswers = New PollAnswers()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollAnswersCollection
        
            Dim coll As PollAnswersCollection = New PollAnswersCollection()
            Dim qry As Query = New Query(PollAnswers.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal PollAnswerId As Object) As PollAnswersCollection 
        
            Dim coll As PollAnswersCollection = New PollAnswersCollection().Where("PollAnswerId", PollAnswerId).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollAnswersCollection 
        
            Dim coll As PollAnswersCollection = New PollAnswersCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal PollAnswerId As Object) as Boolean
        
            Return (PollAnswers.Delete(PollAnswerId) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal PollAnswerId As Object) as Boolean
        
            Return (PollAnswers.Destroy(PollAnswerId) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal PollAnswerId As Guid,ByVal QuestionId As Guid,ByVal Answer As String,ByVal Rank As Nullable(Of Integer))
	   
		    Dim item As PollAnswers = New PollAnswers()
		    
            item.PollAnswerId = PollAnswerId
            
            item.QuestionId = QuestionId
            
            item.Answer = Answer
            
            item.Rank = Rank
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal PollAnswerId As Guid,ByVal QuestionId As Guid,ByVal Answer As String,ByVal Rank As Nullable(Of Integer))
	    
		    Dim item As PollAnswers = New PollAnswers()
		    
				item.PollAnswerId = PollAnswerId
				
				item.QuestionId = QuestionId
				
				item.Answer = Answer
				
				item.Rank = Rank
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
