Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Controller class for PollQuestions
    ''' </summary>
		<System.ComponentModel.DataObject()> Public Partial Class PollQuestionsController
    
        ' Preload our schema..
        Dim thisSchemaLoad As PollQuestions = New PollQuestions()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
				If strUserName.Length = 0 Then
		        
    				If Not System.Web.HttpContext.Current Is Nothing Then
						strUserName = System.Web.HttpContext.Current.User.Identity.Name
					Else
		        		strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
					End If
					Return strUserName
				End If
				Return strUserName
			End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollQuestionsCollection
        
            Dim coll As PollQuestionsCollection = New PollQuestionsCollection()
            Dim qry As Query = New Query(PollQuestions.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
            
        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal PollId As Object) As PollQuestionsCollection 
        
            Dim coll As PollQuestionsCollection = New PollQuestionsCollection().Where("PollId", PollId).Load()
            Return coll
        
        End Function
        
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollQuestionsCollection 
        
            Dim coll As PollQuestionsCollection = New PollQuestionsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal PollId As Object) as Boolean
        
            Return (PollQuestions.Delete(PollId) = 1)
        
        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal PollId As Object) as Boolean
        
            Return (PollQuestions.Destroy(PollId) = 1)
        
        End Function
        
    	
	    ''' <summary>
	    ''' Inserts a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal PollId As Guid,ByVal Question As String,ByVal CreationDate As DateTime,ByVal Memberid As Nullable(Of Guid))
	   
		    Dim item As PollQuestions = New PollQuestions()
		    
            item.PollId = PollId
            
            item.Question = Question
            
            item.CreationDate = CreationDate
            
            item.Memberid = Memberid
            
	    
		    item.Save(UserName)
	   
	   End Sub
    	
	    ''' <summary>
	    ''' Updates a record, can be used with the Object Data Source
	    ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal PollId As Guid,ByVal Question As String,ByVal CreationDate As DateTime,ByVal Memberid As Nullable(Of Guid))
	    
		    Dim item As PollQuestions = New PollQuestions()
		    
				item.PollId = PollId
				
				item.Question = Question
				
				item.CreationDate = CreationDate
				
				item.Memberid = Memberid
				
		    item.MarkOld()
		    item.Save(UserName)
	    
	    End Sub
    End Class
End Namespace
