Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
	''' <summary>
	''' Strongly-typed collection for the PollReactions class.
	''' </summary>
	<Serializable> _
	Public Partial Class PollReactionsCollection 
	Inherits ActiveList(Of PollReactions, PollReactionsCollection)
	    Public Sub New()
		End Sub
	End Class
	''' <summary>
	''' This is an ActiveRecord class which wraps the PollReactions table.
	''' </summary>
	<Serializable> _
	Public Partial Class PollReactions 
	Inherits ActiveRecord(Of PollReactions)
		#Region ".ctors and Default Settings"
		
		Public Sub New()
			SetSQLProps()
			InitSetDefaults()
			MarkNew()
		End Sub
		
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		Public Sub New(ByVal keyID As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByKey(keyID)
		End Sub
		Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByParam(columnName,columnValue)
		End Sub
		Private Sub InitSetDefaults()
			SetDefaults()
		End Sub
		
		Protected Shared Sub SetSQLProps()
			GetTableSchema()
		End Sub
		#End Region
		
		#Region "Schema and Query Accessor"
		
		Public Shared ReadOnly Property Schema() As TableSchema.Table
			Get
				If BaseSchema Is Nothing Then
					SetSQLProps()
				End If
				Return BaseSchema
			End Get
		End Property
		Private Shared Sub GetTableSchema()
			If (Not IsSchemaInitialized) Then
				'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("PollReactions", TableType.Table, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
				'columns
				
                
                Dim colvarReactionId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarReactionId.ColumnName = "ReactionId"
                colvarReactionId.DataType = DbType.Guid
                colvarReactionId.MaxLength = 0
                colvarReactionId.AutoIncrement = false
                colvarReactionId.IsNullable = false
                colvarReactionId.IsPrimaryKey = true
                colvarReactionId.IsForeignKey = false
                colvarReactionId.IsReadOnly = false
                
                
                schema.Columns.Add(colvarReactionId)
                
                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = false
                colvarUserId.IsNullable = false
                colvarUserId.IsPrimaryKey = false
                colvarUserId.IsForeignKey = false
                colvarUserId.IsReadOnly = false
                
                
                schema.Columns.Add(colvarUserId)
                
                Dim colvarCreationDate As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarCreationDate.ColumnName = "CreationDate"
                colvarCreationDate.DataType = DbType.DateTime
                colvarCreationDate.MaxLength = 0
                colvarCreationDate.AutoIncrement = false
                colvarCreationDate.IsNullable = false
                colvarCreationDate.IsPrimaryKey = false
                colvarCreationDate.IsForeignKey = false
                colvarCreationDate.IsReadOnly = false
                
                
                schema.Columns.Add(colvarCreationDate)
                
                Dim colvarReaction As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarReaction.ColumnName = "Reaction"
                colvarReaction.DataType = DbType.String
                colvarReaction.MaxLength = 1024
                colvarReaction.AutoIncrement = false
                colvarReaction.IsNullable = false
                colvarReaction.IsPrimaryKey = false
                colvarReaction.IsForeignKey = false
                colvarReaction.IsReadOnly = false
                
                
                schema.Columns.Add(colvarReaction)
                
                Dim colvarPollId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPollId.ColumnName = "PollId"
                colvarPollId.DataType = DbType.Guid
                colvarPollId.MaxLength = 0
                colvarPollId.AutoIncrement = false
                colvarPollId.IsNullable = false
                colvarPollId.IsPrimaryKey = false
                colvarPollId.IsForeignKey = true
                colvarPollId.IsReadOnly = false
                
                
				colvarPollId.ForeignKeyTableName = "PollQuestions"
                
                schema.Columns.Add(colvarPollId)
                
				BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("PollReactions",schema)
			End If
		End Sub
		Public Shared Function CreateQuery() As Query
			Return New Query(Schema)
		End Function
		
		#End Region
		
		#Region "Props"
	
          
        <XmlAttribute("ReactionId")> _
        Public Property ReactionId As Guid 
			Get
				Return GetColumnValue(Of Guid)("ReactionId")
			End Get
		    
			Set
				SetColumnValue("ReactionId", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("UserId")> _
        Public Property UserId As Guid 
			Get
				Return GetColumnValue(Of Guid)("UserId")
			End Get
		    
			Set
				SetColumnValue("UserId", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("CreationDate")> _
        Public Property CreationDate As DateTime 
			Get
				Return GetColumnValue(Of DateTime)("CreationDate")
			End Get
		    
			Set
				SetColumnValue("CreationDate", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Reaction")> _
        Public Property Reaction As String 
			Get
				Return GetColumnValue(Of String)("Reaction")
			End Get
		    
			Set
				SetColumnValue("Reaction", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("PollId")> _
        Public Property PollId As Guid 
			Get
				Return GetColumnValue(Of Guid)("PollId")
			End Get
		    
			Set
				SetColumnValue("PollId", Value)
			End Set
		End Property
		
		
		
		
		#End Region
		
		
			    
	    
		
		
		
		
		
	    
	    #Region "ForeignKey Methods"
	    
		''' <summary>
		''' Returns a PollQuestions ActiveRecord object related to this PollReactions
		''' </summary>
		Public Property PollQuestions() As Data.PollQuestions
			Get
				Return Data.PollQuestions.FetchByID(Me.PollId)
			End Get
			Set
				SetColumnValue("PollId", Value.PollId)
			End Set
		End Property
	    
	    #End Region
	    
		
	    
	    'no ManyToMany tables defined (0)
	    
		
		#Region "ObjectDataSource support"
		
		''' <summary>
		''' Inserts a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Insert(ByVal varReactionId As Guid,ByVal varUserId As Guid,ByVal varCreationDate As DateTime,ByVal varReaction As String,ByVal varPollId As Guid)
			Dim item As PollReactions = New PollReactions()
			
            item.ReactionId = varReactionId
            
            item.UserId = varUserId
            
            item.CreationDate = varCreationDate
            
            item.Reaction = varReaction
            
            item.PollId = varPollId
            
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		''' <summary>
		''' Updates a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Update(ByVal varReactionId As Guid,ByVal varUserId As Guid,ByVal varCreationDate As DateTime,ByVal varReaction As String,ByVal varPollId As Guid)
			Dim item As PollReactions = New PollReactions()
		    
                item.ReactionId = varReactionId
				
                item.UserId = varUserId
				
                item.CreationDate = varCreationDate
				
                item.Reaction = varReaction
				
                item.PollId = varPollId
				
			item.IsNew = False
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		#End Region
		#Region "Columns Struct"
		Public Structure Columns
			Dim x as Integer
			
            Public Shared ReactionId As String = "ReactionId"
            
            Public Shared UserId As String = "UserId"
            
            Public Shared CreationDate As String = "CreationDate"
            
            Public Shared Reaction As String = "Reaction"
            
            Public Shared PollId As String = "PollId"
            
		End Structure
		#End Region
	End Class
End Namespace
