Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
    ''' <summary>
    ''' Strongly-typed collection for the VwAspnetRoles class.
    ''' </summary>
    <Serializable()> _
    Public Partial Class VwAspnetRolesCollection 
    Inherits ReadOnlyList(Of VwAspnetRoles, VwAspnetRolesCollection)       
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is  Read-only wrapper class for the vw_aspnet_Roles view.
    ''' </summary>
    <Serializable()> _
    Public Partial Class VwAspnetRoles 
    Inherits ReadOnlyRecord(Of VwAspnetRoles)
    
	    #Region "Default Settings"
	    Protected Shared Sub SetSQLProps()
	        GetTableSchema()
	    End Sub
	    #End Region
        #Region "Schema Accessor"
        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If (BaseSchema Is Nothing) Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
	    
	    Private Shared Sub GetTableSchema()
	        If (Not IsSchemaInitialized) Then
	            'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("vw_aspnet_Roles", TableType.View, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
                
                'Columns
                
                Dim colvarApplicationId As New TableSchema.TableColumn(schema)
                colvarApplicationId.ColumnName = "ApplicationId"
                colvarApplicationId.DataType = DbType.Guid
                colvarApplicationId.MaxLength = 0
                colvarApplicationId.AutoIncrement = False
                colvarApplicationId.IsNullable = false
                colvarApplicationId.IsPrimaryKey = False
                colvarApplicationId.IsForeignKey = False
                colvarApplicationId.IsReadOnly = false
                 
                schema.Columns.Add(colvarApplicationId)
                
                Dim colvarRoleId As New TableSchema.TableColumn(schema)
                colvarRoleId.ColumnName = "RoleId"
                colvarRoleId.DataType = DbType.Guid
                colvarRoleId.MaxLength = 0
                colvarRoleId.AutoIncrement = False
                colvarRoleId.IsNullable = false
                colvarRoleId.IsPrimaryKey = False
                colvarRoleId.IsForeignKey = False
                colvarRoleId.IsReadOnly = false
                 
                schema.Columns.Add(colvarRoleId)
                
                Dim colvarRoleName As New TableSchema.TableColumn(schema)
                colvarRoleName.ColumnName = "RoleName"
                colvarRoleName.DataType = DbType.String
                colvarRoleName.MaxLength = 256
                colvarRoleName.AutoIncrement = False
                colvarRoleName.IsNullable = false
                colvarRoleName.IsPrimaryKey = False
                colvarRoleName.IsForeignKey = False
                colvarRoleName.IsReadOnly = false
                 
                schema.Columns.Add(colvarRoleName)
                
                Dim colvarLoweredRoleName As New TableSchema.TableColumn(schema)
                colvarLoweredRoleName.ColumnName = "LoweredRoleName"
                colvarLoweredRoleName.DataType = DbType.String
                colvarLoweredRoleName.MaxLength = 256
                colvarLoweredRoleName.AutoIncrement = False
                colvarLoweredRoleName.IsNullable = false
                colvarLoweredRoleName.IsPrimaryKey = False
                colvarLoweredRoleName.IsForeignKey = False
                colvarLoweredRoleName.IsReadOnly = false
                 
                schema.Columns.Add(colvarLoweredRoleName)
                
                Dim colvarDescription As New TableSchema.TableColumn(schema)
                colvarDescription.ColumnName = "Description"
                colvarDescription.DataType = DbType.String
                colvarDescription.MaxLength = 256
                colvarDescription.AutoIncrement = False
                colvarDescription.IsNullable = true
                colvarDescription.IsPrimaryKey = False
                colvarDescription.IsForeignKey = False
                colvarDescription.IsReadOnly = false
                 
                schema.Columns.Add(colvarDescription)
                
                BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("vw_aspnet_Roles",schema)
	        End If
	    End Sub
	    #End Region
	    
        #Region "Query Accessor"
        Public Shared Function CreateQuery As Query
            Return New Query(Schema)
        End Function
	    #End Region
	    
	    #Region ".ctors"
	    Public Sub New()
	        SetSQLProps()
            SetDefaults()
            MarkNew()
	    End Sub
	    
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		
	    Public Sub New(ByVal keyID As Object)
	        SetSQLProps()
		    LoadByKey(keyID)
	    End Sub
    	
    	Public Sub new(ByVal columnName As String, ByVal columnValue As Object)
    	    SetSQLProps()
            LoadByParam(columnName , columnValue)
    	End Sub
	    #End Region
	    
	    #Region "Props"
	      
        <XmlAttribute("ApplicationId")> _
        Public Property ApplicationId() As Guid 
		    Get
			    Return GetColumnValue(Of Guid)("ApplicationId")
			End Get
            Set(ByVal value As Guid)
			    SetColumnValue("ApplicationId", value)
            End Set
        End Property
	      
        <XmlAttribute("RoleId")> _
        Public Property RoleId() As Guid 
		    Get
			    Return GetColumnValue(Of Guid)("RoleId")
			End Get
            Set(ByVal value As Guid)
			    SetColumnValue("RoleId", value)
            End Set
        End Property
	      
        <XmlAttribute("RoleName")> _
        Public Property RoleName() As String 
		    Get
			    Return GetColumnValue(Of String)("RoleName")
			End Get
            Set(ByVal value As String)
			    SetColumnValue("RoleName", value)
            End Set
        End Property
	      
        <XmlAttribute("LoweredRoleName")> _
        Public Property LoweredRoleName() As String 
		    Get
			    Return GetColumnValue(Of String)("LoweredRoleName")
			End Get
            Set(ByVal value As String)
			    SetColumnValue("LoweredRoleName", value)
            End Set
        End Property
	      
        <XmlAttribute("Description")> _
        Public Property Description() As String 
		    Get
			    Return GetColumnValue(Of String)("Description")
			End Get
            Set(ByVal value As String)
			    SetColumnValue("Description", value)
            End Set
        End Property
	    
	    #End Region
    
	    #Region "Columns Struct"
	    Public Structure Columns
			Dim x as Integer
	        
            Public Shared ApplicationId As String = "ApplicationId"
            
            Public Shared RoleId As String = "RoleId"
            
            Public Shared RoleName As String = "RoleName"
            
            Public Shared LoweredRoleName As String = "LoweredRoleName"
            
            Public Shared Description As String = "Description"
            
	    End Structure
	    #End Region
    End Class
End Namespace
