Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace Data
	''' <summary>
	''' Strongly-typed collection for the WebContent class.
	''' </summary>
	<Serializable> _
	Public Partial Class WebContentCollection 
	Inherits ActiveList(Of WebContent, WebContentCollection)
	    Public Sub New()
		End Sub
	End Class
	''' <summary>
	''' This is an ActiveRecord class which wraps the WebContent table.
	''' </summary>
	<Serializable> _
	Public Partial Class WebContent 
	Inherits ActiveRecord(Of WebContent)
		#Region ".ctors and Default Settings"
		
		Public Sub New()
			SetSQLProps()
			InitSetDefaults()
			MarkNew()
		End Sub
		
		Public Sub New(ByVal useDatabaseDefaults As Boolean)
			SetSQLProps()
			If useDatabaseDefaults = True Then
				ForceDefaults()
			End If
			MarkNew()
		End Sub
		Public Sub New(ByVal keyID As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByKey(keyID)
		End Sub
		Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
			SetSQLProps()
			InitSetDefaults()
			LoadByParam(columnName,columnValue)
		End Sub
		Private Sub InitSetDefaults()
			SetDefaults()
		End Sub
		
		Protected Shared Sub SetSQLProps()
			GetTableSchema()
		End Sub
		#End Region
		
		#Region "Schema and Query Accessor"
		
		Public Shared ReadOnly Property Schema() As TableSchema.Table
			Get
				If BaseSchema Is Nothing Then
					SetSQLProps()
				End If
				Return BaseSchema
			End Get
		End Property
		Private Shared Sub GetTableSchema()
			If (Not IsSchemaInitialized) Then
				'Schema declaration
				Dim schema As TableSchema.Table = New TableSchema.Table("WebContent", TableType.Table, DataService.GetInstance("ClubStarterKitData"))
				schema.Columns = New TableSchema.TableColumnCollection()
				schema.SchemaName = "dbo"
				'columns
				
                
                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "id"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = true
                colvarId.IsNullable = false
                colvarId.IsPrimaryKey = true
                colvarId.IsForeignKey = false
                colvarId.IsReadOnly = false
                
                
                schema.Columns.Add(colvarId)
                
                Dim colvarSection As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarSection.ColumnName = "Section"
                colvarSection.DataType = DbType.String
                colvarSection.MaxLength = 100
                colvarSection.AutoIncrement = false
                colvarSection.IsNullable = false
                colvarSection.IsPrimaryKey = false
                colvarSection.IsForeignKey = false
                colvarSection.IsReadOnly = false
                
                
                schema.Columns.Add(colvarSection)
                
                Dim colvarSectionContent As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarSectionContent.ColumnName = "SectionContent"
                colvarSectionContent.DataType = DbType.String
                colvarSectionContent.MaxLength = 2147483647
                colvarSectionContent.AutoIncrement = false
                colvarSectionContent.IsNullable = true
                colvarSectionContent.IsPrimaryKey = false
                colvarSectionContent.IsForeignKey = false
                colvarSectionContent.IsReadOnly = false
                
                
                schema.Columns.Add(colvarSectionContent)
                
                Dim colvarDteTime As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDteTime.ColumnName = "DteTime"
                colvarDteTime.DataType = DbType.DateTime
                colvarDteTime.MaxLength = 0
                colvarDteTime.AutoIncrement = false
                colvarDteTime.IsNullable = true
                colvarDteTime.IsPrimaryKey = false
                colvarDteTime.IsForeignKey = false
                colvarDteTime.IsReadOnly = false
                
                
                schema.Columns.Add(colvarDteTime)
                
				BaseSchema = schema
				
				'add this schema to the provider
                'so we can query it later
                DataService.Providers("ClubStarterKitData").AddSchema("WebContent",schema)
			End If
		End Sub
		Public Shared Function CreateQuery() As Query
			Return New Query(Schema)
		End Function
		
		#End Region
		
		#Region "Props"
	
          
        <XmlAttribute("Id")> _
        Public Property Id As Integer 
			Get
				Return GetColumnValue(Of Integer)("id")
			End Get
		    
			Set
				SetColumnValue("id", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("Section")> _
        Public Property Section As String 
			Get
				Return GetColumnValue(Of String)("Section")
			End Get
		    
			Set
				SetColumnValue("Section", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("SectionContent")> _
        Public Property SectionContent As String 
			Get
				Return GetColumnValue(Of String)("SectionContent")
			End Get
		    
			Set
				SetColumnValue("SectionContent", Value)
			End Set
		End Property
		
		
		  
        <XmlAttribute("DteTime")> _
        Public Property DteTime As Nullable(Of DateTime) 
			Get
				Return GetColumnValue(Of Nullable(Of DateTime))("DteTime")
			End Get
		    
			Set
				SetColumnValue("DteTime", Value)
			End Set
		End Property
		
		
		
		
		#End Region
		
		
			    
	    
		
		
		
		
		
	    
	    'no foreign key tables defined (0)
	    
		
	    
	    'no ManyToMany tables defined (0)
	    
		
		#Region "ObjectDataSource support"
		
		''' <summary>
		''' Inserts a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Insert(ByVal varSection As String,ByVal varSectionContent As String,ByVal varDteTime As Nullable(Of DateTime))
			Dim item As WebContent = New WebContent()
			
            item.Section = varSection
            
            item.SectionContent = varSectionContent
            
            item.DteTime = varDteTime
            
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		''' <summary>
		''' Updates a record, can be used with the Object Data Source
		''' </summary>
		Public Shared Sub Update(ByVal varId As Integer,ByVal varSection As String,ByVal varSectionContent As String,ByVal varDteTime As Nullable(Of DateTime))
			Dim item As WebContent = New WebContent()
		    
                item.Id = varId
				
                item.Section = varSection
				
                item.SectionContent = varSectionContent
				
                item.DteTime = varDteTime
				
			item.IsNew = False
			If Not System.Web.HttpContext.Current Is Nothing Then
				item.Save(System.Web.HttpContext.Current.User.Identity.Name)
			Else
				item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
			End If
		End Sub
		#End Region
		#Region "Columns Struct"
		Public Structure Columns
			Dim x as Integer
			
            Public Shared Id As String = "id"
            
            Public Shared Section As String = "Section"
            
            Public Shared SectionContent As String = "SectionContent"
            
            Public Shared DteTime As String = "DteTime"
            
		End Structure
		#End Region
	End Class
End Namespace
