<!-- 
Copyright (c) 2006, Mark Bracewell (bracewell at wgg dot com)
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 
*

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
* The name Mark Bracewell may not be used to endorse or promote products
derived from this software without specific prior written permission. 
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL MARK BRACEWELL BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 -->
<%@ Control Language="VB" ClassName="ForumUser" Strict="false" %>
<%@ Import Namespace="ClubStarterKit.Data" %>
<%@ Import Namespace="SubSonic" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.Sql" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<script runat="server">
    Private _memberid As Object
    Private _showavatar As Boolean = True
    Private _showemail As Boolean = False
    Private _showdetails As Boolean = False
    Private _showblogs As Boolean = False
    Private _showbasicinfo As Boolean = True
    Private _cssclass As String = "forumuser"
    Private _showonline As Boolean = True
    
    Public Property MemberID() As Object
        Get
            Return _memberid
        End Get
        Set(ByVal value As Object)
            _memberid = value
        End Set
    End Property
    
    Public Property ShowAvatar() As Boolean
        Get
            Return _showavatar
        End Get
        Set(ByVal value As Boolean)
            _showavatar = value
        End Set
    End Property

    Public Property ShowEmail() As Boolean
        Get
            Return _showemail
        End Get
        Set(ByVal value As Boolean)
            _showemail = value
        End Set
    End Property

    Public Property ShowDetails() As Boolean
        Get
            Return _showdetails
        End Get
        Set(ByVal value As Boolean)
            _showdetails = value
        End Set
    End Property

    Public Property ShowBasicInfo() As Boolean
        Get
            Return _showbasicinfo
        End Get
        Set(ByVal value As Boolean)
            _showbasicinfo = value
        End Set
    End Property

    Public Property ShowOnline() As Boolean
        Get
            Return _showonline
        End Get
        Set(ByVal value As Boolean)
            _showonline = value
        End Set
    End Property
    
    Public Property ShowBlogs() As Boolean
        Get
            Return _showblogs
        End Get
        Set(ByVal value As Boolean)
            _showblogs = value
        End Set
    End Property

    Public Property CssClass() As String
        Get
            Return _cssclass
        End Get
        Set(ByVal value As String)
            _cssclass = value
        End Set
    End Property
    
    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs)
        
        If MemberID Is Nothing Or IsDBNull(MemberID) Then
            UserBox.Visible = False
            Return
        End If
        Dim MemGuid As Guid = CType(MemberID, Guid)
        If MemGuid.Equals(Guid.Empty) Then
            UserBox.Visible = False
            Return
        End If
        
        Dim user As MembershipUser = Membership.GetUser(MemGuid)
        Dim member As New Member(MemGuid)
        
        Dim UserWantsAvatars As Boolean = True
        If Page.User.Identity.IsAuthenticated Then
            Dim currentmem As New MemberProfile(MemberProfile.Columns.Memberid, Membership.GetUser().ProviderUserKey)
            UserWantsAvatars = currentmem.Showavatars
        End If
        UserBox.CssClass = CssClass
        ProfileLink.NavigateUrl = "profile.aspx?id=" & MemberID.ToString()
        AvatarProfileLink.NavigateUrl = "profile.aspx?id=" & MemberID.ToString()
        DisplayName.Text = ClubStarterKit.Web.Members.FirstAndLastName(MemGuid)
        If ShowAvatar And UserWantsAvatars Then
            AvatarBox.Visible = True
            Avatar.AlternateText = ClubStarterKit.Web.Members.FirstAndLastName(MemGuid)
            Avatar.ImageUrl = "~\UserControls\AvatarImagefetch.ashx?Memberid=" & MemberID.ToString
        End If
        If ShowBasicInfo Then
            BasicInfoBox.Visible = True
            Posts.Text = member.Posts.ToString()
            NumAnswers.Text = ClubStarterKit.Web.Forum.NumAnswers(MemberID).ToString()
            Joined.Text = user.CreationDate.ToString("d")
        End If
        If ShowOnline Then
            OnlineImg.Visible = True
            OnlineImg.AlternateText = CStr(IIf(user.IsOnline(), "Online", "Offline"))
            OnlineImg.ImageUrl = String.Format("~/App_Themes/" & Page.Theme.ToString() & "/images/{0}.gif", OnlineImg.AlternateText)
        End If
        If ShowEmail Then
            EmailBox.Visible = True
            Email.Text = String.Format("<a href='mailto:{0}'>{1}</a>", user.Email, user.Email)
        End If
        If ShowDetails Then
            DetailsBox.Visible = True
            LastLoginDate.Text = user.LastLoginDate.ToString("d")
            LastPostDate.Text = member.LastPostDate.ToString("d")
            LoginName.Text = user.UserName
            Phone.Text = member.Phone
            Address.Text = member.Address
        End If
        If ShowBlogs Then
            Blogs.Visible = True
            NumPosts.Text = ClubStarterKit.Web.Blogs.NumPostsByMem(MemberID)
        End If
        iadmin.Visible = Roles.IsUserInRole(user.UserName, "Moderator")
    End Sub
</script>

<asp:Panel runat="server" ID="UserBox">
    <h3>
        <asp:HyperLink ID="ProfileLink" runat="server">
            <asp:Label ID="DisplayName" runat="server" /></asp:HyperLink></h3>
    <asp:Panel ID="AvatarBox" Visible="false" runat="server">
        <asp:HyperLink ID="AvatarProfileLink" runat="server">
        <asp:Image BorderColor="#000000" BorderStyle="solid" BorderWidth="1"
            ID="Avatar" runat="server" /></asp:HyperLink>
    </asp:Panel>
    <asp:Panel Visible="false" runat="server" ID="Blogs">
        Blog Posts:
        <asp:Label ID="NumPosts" runat="server" Text="Label"></asp:Label>
        <br />
    </asp:Panel>
    <asp:Panel ID="BasicInfoBox" runat="server" Visible="false">
        Joined:
        <asp:Label ID="Joined" runat="server"></asp:Label>
        <br />
        Posts:
        <asp:Label ID="Posts" runat="server" />
        <br />
        Posts Answered:
        <asp:Label ID="NumAnswers" runat="server" />
    </asp:Panel>
    <asp:Image ID="OnlineImg" runat="server" Visible="false" />
    <br /> <asp:Image ID="iadmin" runat="server" SkinID="moderator" Visible="false" />
    <asp:Panel runat="server" ID="EmailBox">
        <asp:Literal ID="Email" runat="server"></asp:Literal>
    </asp:Panel>
    <asp:Panel Visible="false" runat="server" ID="DetailsBox">
        Login Name:
        <asp:Label ID="LoginName" runat="server" Text="Label"></asp:Label>
        <br />
        Last Login:
        <asp:Label ID="LastLoginDate" runat="server" Text="Label"></asp:Label>
        <br />
        Last Post:
        <asp:Label ID="LastPostDate" runat="server" Text="Label"></asp:Label>
        <br />
        Address:
        <asp:Label ID="Address" runat="server" Text="Label"></asp:Label>
        <br />
        Phone:
        <asp:Label ID="Phone" runat="server" Text="Label"></asp:Label>
    </asp:Panel>
    
</asp:Panel>
