<%@ WebHandler Language="VB" Class="ImageFetch" %>

Imports System.Web
Imports System.Data.SqlClient
Imports System.Data
Imports System.IO
Imports SubSonic
Imports ClubStarterKit.Data

Public Class ImageFetch : Implements IHttpHandler

    Const BUFFERSIZE As Integer = 1024
    Private imgStore As ImageUtils.ImageLocation
    
    Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return True
        End Get
    End Property
    
    Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim response As Web.HttpResponse = context.Response
        Dim request As Web.HttpRequest = context.Request
        response.ContentType = "image/jpeg"
        response.Cache.SetCacheability(HttpCacheability.Public)
        response.BufferOutput = False
        'imgStore = ImageUtils.GetLocation()
        If ConfigurationManager.AppSettings("StoreImagesOnFile").ToString() = "True" Then
            imgStore = ImageUtils.ImageLocation.FileSystem
        Else
            imgStore = ImageUtils.ImageLocation.Database
        End If
        'imgStore = ImageUtils.ImageLocation.FileSystem

        writeSingleImage(CInt(request.QueryString("ImageID")), CInt(request.QueryString("Size")), response.OutputStream)
        response.End()
        
    End Sub
 
    Public Sub writeSingleImage(ByVal ImageID As Integer, ByVal size As Integer, ByVal output As IO.Stream)
        'Get the image based on where it is stored, either filesystem or database.

        If imgStore = ImageUtils.ImageLocation.Database Then
            Dim img As New Images(Images.Columns.Id, ImageID)
            Dim d As Byte()
            Select Case size
                Case 0 : d = img.Largeimage
                Case 1 : d = img.Thumbimage
                Case 2 : d = img.Origimage
            End Select

            output.Write(d, 0, d.Length)
            
        ElseIf imgStore = ImageUtils.ImageLocation.FileSystem Then
            'Get the filename from the database
            Dim img As New Image(Image.Columns.Id, ImageID)

            Dim fileName As String = img.ImageFileName

            Select Case size
                Case 0
                    'largeImage
                    fileName = "large" & fileName
                Case 1
                    'thumbnail
                    fileName = "tmb" & fileName
                Case 2
                    'original image
                    'fileName already has the original image filename 
            End Select

            fileName = HttpContext.Current.Request.PhysicalApplicationPath & "pictures\" & fileName
            Dim imageFile As New FileStream(fileName, FileMode.Open, FileAccess.Read)
            Dim len As Integer = CInt(imageFile.Length)
            Dim d(len) As Byte
            imageFile.Read(d, 0, len)
            imageFile.Close()
            output.Write(d, 0, d.Length)
        End If
    End Sub

End Class