﻿<%@ Control Language="VB" ClassName="Photos_formpicker" %>


<script runat="server">
    
    Const CLIENTSCRIPTPREFIX As String = "__FormPhotoPicker_"
    Private imageFileLocation As ImageUtils.ImageLocation
    
    Property ImageId() As Object
        Get
            EnsureChildControls()
            If viewswitch.ActiveViewIndex = 1 Then
                Return CInt(selectedimage.Value)
            Else
                Dim id As Object = ViewState("ImageID")
                If id Is DBNull.Value Then
                    Return 0
                Else
                    Return CInt(id)
                End If
            End If

        End Get
        Set(ByVal value As Object)
            ViewState("ImageID") = value
        End Set
    End Property
    
    Public Property SmallImage() As Boolean
        Get
            Dim o As Object = ViewState("SmallImage")
            If Not o Is Nothing Then
                Return CBool(o)
            Else
                Return False
            End If
        End Get
        Set(ByVal value As Boolean)
            ViewState("SmallImage") = value
        End Set
    End Property
    
    Function imagesize() As String
        If SmallImage = True Then
            Return "1"
        Else
            Return "0"
        End If
    End Function
    
    Protected Sub Page_PreRender(ByVal sender As Object, ByVal e As System.EventArgs)
        RenderScript()
        If CInt(ImageId) <> 0 Then
            imagepreview.ImageUrl = "~/UserControls/imagefetch.ashx?ImageID=" & CInt(ImageId) & "&Size=" & imagesize()
        End If
    End Sub
    
    Protected Sub ShowPickExistingBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        viewswitch.SetActiveView(pickexistingview)
    End Sub

    Protected Sub ShowUploadBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        viewswitch.SetActiveView(uploadimageview)
    End Sub
    
    Private Sub DetermineStorageLocation()
        'Read image storage location from web.config and assign to imageFileLocation.
        imageFileLocation = ImageUtils.GetLocation()
    End Sub

    Private Sub AdjustSQLDataSources()
        Dim sql As SqlDataSource = CType(pickexistingview.FindControl("SQLDataSource2"), SqlDataSource)
        Select Case imageFileLocation
            Case ImageUtils.ImageLocation.Database
                With sql
                    .SelectCommand = "SELECT title, id FROM images WHERE (album = @album)"
                End With
            Case ImageUtils.ImageLocation.FileSystem
                With sql
                    .SelectCommand = "SELECT title, id FROM image WHERE (album = @album)"
                End With
        End Select
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)
        If Not IsPostBack Then
            viewswitch.SetActiveView(main)
        End If
        DetermineStorageLocation()
        AdjustSQLDataSources()
    End Sub
    
    Protected Sub ClearBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        ImageId = 0
    End Sub
    
    Sub RenderScript()
        Dim sb As New Text.StringBuilder
        
        sb.AppendLine("var " & CLIENTSCRIPTPREFIX & "selecteditem = null;")
        sb.AppendLine("function " & CLIENTSCRIPTPREFIX & "SelectItem(element, newimageid)")
        sb.AppendLine("{")
        sb.AppendLine("    if (" & CLIENTSCRIPTPREFIX & "selecteditem != null)")
        sb.AppendLine("    {")
        sb.AppendLine("        " & CLIENTSCRIPTPREFIX & "selecteditem.className='unselected';")
        sb.AppendLine("    }")
        sb.AppendLine("    " & CLIENTSCRIPTPREFIX & "selecteditem = element; ")
        sb.AppendLine("    " & CLIENTSCRIPTPREFIX & "selecteditem.className='selected';")
        sb.AppendLine("    document.getElementById('" & selectedimage.ClientID & "').value = newimageid;")
        sb.AppendLine("}")
        
        Page.ClientScript.RegisterClientScriptBlock(Me.GetType, "SelectItem", sb.ToString, True)
    End Sub
    
    
    Protected Sub existingChosen_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        
        'ImageId = CInt("0" & AlbumList2.SelectedValue)
        ImageId = CInt("0" & selectedimage.Value.ToString())
        viewswitch.SetActiveView(main)
    End Sub
    
    Protected Sub Cancel_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        viewswitch.SetActiveView(main)
    End Sub
    
    Protected Sub UploadBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim newimageid As Integer
        If imageFileLocation = ImageUtils.ImageLocation.Database Then
            newimageid = ImageUtils.uploadImage(Title.Text, CInt(AlbumList2.SelectedValue), FileUpload1.FileContent)
        ElseIf imageFileLocation = ImageUtils.ImageLocation.FileSystem Then
            newimageid = ImageUtils.uploadImage(Title.Text, CInt(AlbumList2.SelectedValue), FileUpload1.FileContent, Server.MapPath("~\Pictures") & "\")
        End If
        ImageId = newimageid
        viewswitch.SetActiveView(main)
    End Sub


Protected Sub Setowner(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.SqlDataSourceSelectingEventArgs)
  dim param as Data.Common.DbParameter =    e.Command.Parameters("@owner")
     param.DbType=Data.DbType.Guid
     if page.User.Identity.IsAuthenticated then
          param.Value=Membership.GetUser().ProviderUserKey 
           else 
           param.Value=dbnull.Value
           end if 
     End Sub
</script>

<div class="controlblock">
    <asp:MultiView ID="viewswitch" runat="server">
        <asp:View ID="main" runat="server">
            <asp:Image runat="server" SkinID="preview" ID="imagepreview"  />
            <div class="contextbuttons">
                <Club:RolloverButton ID="ShowUploadBtn" Text="Upload Image" runat="server"
                    OnClick="ShowUploadBtn_Click" />
                <Club:RolloverButton ID="ShowPickExistingBtn" Text="Existing Image"
                    runat="server" OnClick="ShowPickExistingBtn_Click" />
                <Club:RolloverButton ID="ClearBtn" Text="Clear" runat="server" OnClick="ClearBtn_Click" />
            </div>
        </asp:View>
        <asp:View ID="pickexistingview" runat="server">
            <asp:SqlDataSource ID="SqlDataSource1" runat="server" SelectCommand="SELECT albumid, title FROM Albums WHERE (ownerid = @owner) OR (isprivate = 0)"
ConnectionString="<%$ ConnectionStrings:ClubSiteDB %>" OnSelecting="setowner">
<SelectParameters>
                    <asp:Parameter Name="owner" />
                </SelectParameters>
</asp:SqlDataSource>

            <asp:SqlDataSource ID="SqlDataSource2" runat="server" ConnectionString="<%$ ConnectionStrings:ClubSiteDB %>"
                SelectCommand="SELECT title, id FROM images WHERE (album = @album)">
                <SelectParameters>
                    <asp:ControlParameter Name="album" ControlID="AlbumList" PropertyName="SelectedValue"
                        DefaultValue="1" />
                </SelectParameters>
            </asp:SqlDataSource>
            Select an image:
            <p>
                <asp:Label ID="Label1" runat="server" />
                Photo album: &nbsp; &nbsp;
                <asp:DropDownList ID="AlbumList" runat="server" DataSourceID="SqlDataSource1" DataTextField="title"
                    DataValueField="albumid" AutoPostBack="true" />
            </p>
            <div class="scrollablelist">
                <asp:HiddenField ID="selectedimage" runat="server" Value="0" />
                <asp:DataList ID="DataList1" runat="server" DataSourceID="SqlDataSource2" DataKeyField="id"
                    RepeatColumns="4" CellSpacing="2" CssClass="scrolledtable">
                    <ItemTemplate>
                        <div onclick="<%# CLIENTSCRIPTPREFIX & "SelectItem(this, '" & CStr(Eval("ID")) & "')" %>"
                            class="unselected">
                            <asp:Image ImageUrl='<%# "imagefetch.ashx?size=1&imageid=" & Cstr(Eval("id")) %>'
                                runat="server" ID="idImage" CssClass="selectablephoto" /><br />
                            <asp:Label Text='<%# Eval("title") %>' runat="server" ID="titleLabel" />
                        </div>
                    </ItemTemplate>
                </asp:DataList>
            </div>
            <p>
            </p>
            <Club:RolloverButton ID="existingChosen" Text="Use selection" runat="server"
                OnClick="existingChosen_Click" />
            <Club:RolloverButton ID="Cancel1" Text="Cancel" runat="server" OnClick="Cancel_Click" />
        </asp:View>
        <asp:View ID="uploadimageview" runat="server">
            <asp:SqlDataSource ID="SqlDataSource3" runat="server" SelectCommand="SELECT albumid, title FROM Albums WHERE (ownerid = @owner) OR (isprivate = 0)"
                ConnectionString="<%$ ConnectionStrings:ClubSiteDB %>" OnSelecting="setowner">
                <SelectParameters>
                    <asp:Parameter Name="owner" />
                </SelectParameters>
            </asp:SqlDataSource>
            Select a file using the browse button, enter a caption title and click Upload Image.
            <asp:Label ID="ErrorLabel" runat="server" />
            <table>
                <tr>
                    <td>
                        Album to upload to:</td>
                    <td>
                        <asp:DropDownList ID="AlbumList2" runat="server" DataSourceID="SqlDataSource3" DataTextField="title"
                            DataValueField="albumid">
                        </asp:DropDownList></td>
                </tr>
                <tr>
                    <td>
                        File:</td>
                    <td>
                        <asp:FileUpload ID="FileUpload1" runat="server" /></td>
                </tr>
                <tr>
                    <td>
                        Image title:</td>
                    <td>
                        <asp:TextBox ID="Title" runat="server" />
                    </td>
                </tr>
            </table>
            <p>
            </p>
            <Club:RolloverButton ID="UploadBtn" runat="server" Text="Upload Image" OnClick="UploadBtn_Click" />
            <Club:RolloverButton ID="Cancel2" runat="server" Text="Cancel" OnClick="Cancel_Click" />
        </asp:View>
    </asp:MultiView>
</div>
