<%@ WebHandler Language="VB" Class="TempImageFetch" %>

Imports System.Web
Imports System.Data.SqlClient
Imports System.Data
Imports System.IO
Imports SubSonic
Imports ClubStarterKit.Data

Public Class TempImageFetch : Implements IHttpHandler

    Const BUFFERSIZE As Integer = 1024
    Private imgStore As ImageUtils.ImageLocation
    
    Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return True
        End Get
    End Property
    
    Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim response As Web.HttpResponse = context.Response
        Dim request As Web.HttpRequest = context.Request
        response.ContentType = "image/jpeg"
        response.Cache.SetCacheability(HttpCacheability.Public)
        response.BufferOutput = False
        imgStore = ImageUtils.GetLocation()

        writeSingleImage(CInt(request.QueryString("ImageID")), response.OutputStream)
        response.End()
        
    End Sub
 
    Public Sub writeSingleImage(ByVal ImageID As Integer, ByVal output As IO.Stream)
        If imgStore = ImageUtils.ImageLocation.Database Then
            Dim img As New TempImagesDB(TempImagesDB.Columns.Id, ImageID)
            Dim d As Byte() = img.Thumb
            
            output.Write(d, 0, d.Length)
            
        ElseIf imgStore = ImageUtils.ImageLocation.FileSystem Then
            Dim img As New TempImagesFile(TempImagesFile.Columns.Id, ImageID)

            Dim fileName As String = "tmb" & img.Filename

            fileName = HttpContext.Current.Request.PhysicalApplicationPath & "TempUpload\" & fileName
            Dim imageFile As New FileStream(fileName, FileMode.Open, FileAccess.Read)
            Dim len As Integer = CInt(imageFile.Length)
            Dim d(len) As Byte
            imageFile.Read(d, 0, len)
            imageFile.Close()
            output.Write(d, 0, d.Length)
        End If
    End Sub

End Class